// thomas@fam-kuster.ch
// Copyleft: GNU-Public License Version 2 oder hher (http://www.gnu.org)

#include <stdio.h>    //stdio.h
#include <termios.h>  //termios.h
#include <term.h>     //term.h
#include <curses.h>   //curses.h
#include <unistd.h>   //unistd.h
//Start eigene
#include <fcntl.h>    //fcntl.h

static struct termios initial_settings, new_settings;
static int peek_character = -1;

void init_keyboard();
void close_keyboard();

//Start eigene
int ausgabe_an();
int verzoegerung();
int zuruecksetzen();
//Ende eigene

int kbhit();
int readch();

//Start eigene
int warten = 10, max_v = 500000; //max_v = maximale Verzgerung zwischen dem Umschalten
int interface;

int main()
{
  int ch = 0;

  /* Start eigene Variablen */
  //int interface;
  int s = 0, i = 0;
  int s_alt;
  char ausgabe[4], kanal[4] = "0123";

  /* Ende eigene Variablen */

  /* Interface Anschluss zum schreiben ffnen */
  interface = open("/dev/lp0", O_WRONLY|O_APPEND);  //zum testen Konsole nehmen zum Beispiel tty2


  zuruecksetzen(); //alles ausschalten

  init_keyboard();
  printf("\nzum beenden 'q' drcken\n\n");
  while(ch != 'q')
    {
      // printf("durchlauf Schlaufe\n");

      ch = 0; //zurcksetzen Tastenvariable

      if(kbhit())
      	{
	  ch = readch();
	}

        /* Start Einbau eigener Quelltext (gedrckte Taste ist in ch gespeichert)*/

      //printf("durchlauf und taste %c\n", ch);

	if(ch == 'l')
	  warten += 10000;

	if(ch == 'r')
	  warten -= 10000;

    i++;
    if(warten >= 0)
      {
	s_alt = s;
	s++;
        if(s >= 4)
	  s = 0;

	// printf("warten ist grsser oder gleich0\ns = %d\ns_alt = %d\n", s, s_alt);
      }

    if(warten < 0)
      {
	s_alt = s;
	s--;
        if(s <= -1)
	  s = 3;

	// printf("warten ist kleiner 0\ns = %d\ns_alt = %d\n", s, s_alt);
      }

    ausgabe[0] = kanal[s];
    ausgabe[1] = '+';
    ausgabe[2] = kanal[s_alt];
    ausgabe[3] = '-';
    ausgabe[4] = '\0'; 

    ausgabe_an(ausgabe, 4); //ausgeben an Interface

    // printf("warte etwas\n");
    verzoegern(max_v - abs(warten));

        /* Ende Einbau eigener Quelltext */

    }
  close_keyboard();
  exit(0);
}

void init_keyboard()
  {
    tcgetattr(0,&initial_settings);
    new_settings = initial_settings;
    new_settings.c_lflag &= ~ICANON;
    new_settings.c_lflag &= ~ECHO;
    new_settings.c_lflag &= ~ISIG;

    new_settings.c_cc[VMIN] = 1;
    new_settings.c_cc[VTIME] = 0;
    tcsetattr(0, TCSANOW, &new_settings);
  }

void close_keyboard()
  {
    tcsetattr(0, TCSANOW, &initial_settings);
  }

int kbhit()
  {
    char ch;
    int nread;
    
    if(peek_character != -1)
      return 1;
    new_settings.c_cc[VMIN]=0;
    tcsetattr(0, TCSANOW, &new_settings);
    nread = read(0,&ch,1);
    new_settings.c_cc[VMIN]=1;
    tcsetattr(0, TCSANOW, &new_settings);
    
    if(nread == 1)
      {
        peek_character = ch;
	return 1;
      }
    return 0;
  }

int readch()
  {
    char ch;
    if(peek_character != -1)
      {
	ch = peek_character;
	peek_character = -1;
	return ch;
      }
    read(0,&ch,1);
    return ch;
  }

//Start eigene

/* gibt den bergebenen Wert ausgabe auf lp0 aus (lnge muss als zweiter parameter angegeben werden -> laenge) */

int ausgabe_an(ausgabe, laenge)
{
  //printf("laenge = %d\n", was_laenge);
 
  //int interface;
  //interface = open("/dev/tty2", O_WRONLY|O_APPEND);
  if ((write(interface, ausgabe, laenge)) != laenge)
  write(2, "Fehler beim Schreiben auf /dev/lp0\n", 35);

  // printf("sizeof = %d\n", sizeof(plus) );
  //exit(0);
}

int verzoegern(wert)
{
  usleep(wert);
  printf("Die Wartezeit betrgt %d Mikrosekunden.\n", wert);
}

int zuruecksetzen()
{
  printf("zurcksetzen");
  ausgabe_an("0-1-2-3-4-5-6-7-", 16);
}

